#ifndef BF_IA32_H
#define BF_IA32_H

#include <bf_ia32ops.h>

typedef unsigned int uint32_t;
typedef unsigned char *cp_t;

#define P EAX
#define V EBX

#define CALL_V(addr) {\
	MOV_RM(cp,P,ESP,0);\
	MOV_RM(cp,P,EBP,8);\
	CALL(cp,addr);\
	MOV_MR(cp,EBP,P,8); \
}

#define COMPILE(file) {\
	PUSH(cp,EBP); \
	MOV_RR(cp,ESP,EBP); \
	MOV_MR(cp,EBP,P,8); \
	SUB_I(cp,0x8,ESP);\
	compile_block((file),4,0); \
	MOV_MR(cp,P,EAX,0); \
	ADD_I(cp,0x8,ESP);\
	LEAVE(cp);\
	RET(cp); \
}

#define INCP(n) { ADD_I(cp,4*(n),P); i++; }
#define DECP(n) { ADD_I(cp,-4*(n),P); i++; }
#define INCV(n) {\
	MOV_RR(cp,P,ECX); \
	MOV_MR(cp,P,P,0); \
	ADD_I(cp,(n),P); \
	MOV_RM(cp,P,ECX,0); \
	MOV_RR(cp,ECX,P); \
}

#define DECV(n) {\
	MOV_RR(cp,P,ECX); \
	MOV_MR(cp,P,P,0); \
	ADD_I(cp,-1*(n),P); \
	MOV_RM(cp,P,ECX,0); \
	MOV_RR(cp,ECX,P); \
}

#define BEGIN(addr) {\
	cp_t cp_jz; \
	int label = (int) cp; \
	int dist; \
	MOV_RR(cp,P,ECX); \
	MOV_MR(cp,P,P,0); \
	CMP_I(cp,0); \
	MOV_RR(cp,ECX,P); \
	cp_jz = cp;\
	JZ(cp,0);\
	MOV_RR(cp,ECX,P); \
	compile_block(file,label,depth+1); \
	dist = cp - cp_jz - 6;\
	JZ(cp_jz,dist);\
}

#define END(addr) {\
	MOV_RR(cp,P,ECX); \
	MOV_MR(cp,P,P,0); \
	CMP_I(cp,0); \
	MOV_RR(cp,ECX,P); \
	JNZ(cp,((cp_t)label)-cp-4);\
	MOV_RR(cp,ECX,P); \
}

#define REG(uc,p) ((uc)->uc_mcontext.gregs[p])

#endif
