#ifndef BF_SGI_H
#define BF_SGI_H

#include <bf_mipsops.h>

typedef mips_ins_t *cp_t;

#define P 4
#define V 8

#define CALL_V(addr) {\
	LUI(cp,T9,hi(addr));\
	ORI(cp,T9,T9,lo(addr));\
	SW(cp,SP,P,24);\
	JALR(cp,T9,RA);\
	NOP(cp);\
	LW(cp,SP,P,24); \
	i += 6; \
}

#define COMPILE(file) \
	ADDIU(cp,SP,SP,-48); \
	SD(cp,SP,GP,16); \
	SD(cp,SP,FP,8); \
	SD(cp,SP,RA,0); \
	compile_block((file),4,0); \
	LD(cp,SP,RA,0); \
	LD(cp,SP,FP,8); \
	LD(cp,SP,GP,16); \
	OR(cp,2,V,0); \
	JR(cp,31); \
	ADDIU(cp,SP,SP,48);

#define INCP(n) { ADDIU(cp,P,P,4*(n)); i++; }
#define DECP(n) { ADDIU(cp,P,P,-4*(n)); i++; }
#define INCV(n) {\
	LW(cp,P,V,0); \
	ADDIU(cp,V,V,(n)); \
	SW(cp,P,V,0); \
	i += 3; \
}

#define DECV(n) {\
	LW(cp,P,V,0);\
	ADDIU(cp,V,V,-1*(n)); \
	SW(cp,P,V,0); \
	i += 3; \
}

#define BEGIN() {\
	cp_t *cp_bak; \
	int dist; \
	LW(cp,P,V,0); \
	i++; \
	cp_bak = cp++; \
	dist = i; \
	NOP(cp); \
	i+=2; \
	compile_block(file,dist-2,depth+1); \
	BEQ(cp_bak,V,0,i-dist-3); \
}

#define END() {\
	LW(cp,P,V,0); \
	BNE(cp,V,0,label-i); \
	NOP(cp); \
	i+=3; \
}

#define REG(uc,p) ((uc)->uc_mcontext.__gregs[p])

#endif

